# GP toolbox

Blender addon - Various tool to help with grease pencil in animation productions.

**[Download latest](https://gitlab.com/autour-de-minuit/blender/gp_toolbox/-/archive/master/gp_toolbox-master.zip)**

<!-- ### [Demo Youtube]() -->

**[Readme Doc in French (Documentation en Français et plus détaillée)](https://gitlab.com/autour-de-minuit/blender/gp_toolbox/-/blob/master/README_FR.md)**

---  

## Description

<!-- ![pseudo color demo](https://github.com/Pullusb/images_repo/blob/master/GPT_pseudo_tint.gif)
*In this demo F9 is pressed to call the "redo panel" and modify the hue offset with constant update*   -->
  
In sidebar (N) > Gpencil > Toolbox

<!-- - Pseudo tint color : Tints each GP layer of selected GP objects with a pseudo random tints to quickly identify which lines belong to which layer.  
/!\ Using this will override the tint and tint factor on your layer (so they will be lost if you used it for a specific layer) -->

## Addon preferences

important point of addon preferences:  

Set path to the palette folder (there is a json palette IO but you an also put a blend and use a blend importer)

Note about palette : For now the importer is not working with linked palette as it's not easy for animator (there are properties of the material you cannot access and the link grey-out fade the real color in UIlist preview)


### Passive action

Add an "on save" Handler that trigger relative remap of all path.

### function

- Mirror flip : If in cam view flip the camera X scale value (you can see and draw mnirrored to see problems)

<!-- - Overlay toggle : (toggle pref and overlay)  -->

- quick access to scene camera passepartout toggle and opacity

- quick access to scene camera background images visibility with individual references toggle.

- Basic playblast and viewport playblast:

  - dedicated resolution percentage value

  - can auto launch and/or auto open folder at finished (option in addon preferences)

- Jump to GP keyframe :

  - Choose key to Auto bind in addon prefs (since 0.9.3).  
  > Manual setup: Add two keymap shortcut in _windows_ or _screen(global)_ with indentifier `screen.gp_keyframe_jump`, one should have `next` toggled off to jump back

- GP paint cutter tool temporary switch shortcut
  - Map manually to a key with `wm.temp_cutter` (This one needs "Any" as press mode) or `wm.sticky_cutter` (Modal sticky-key version)

- Snap cursor to GP canvas operator accessible with `view3d.cusor_snap` 
  - Map nanually (might be autoreplaced according to version) by replacing entry using `view3d.cursor3d` in 3D View category (defaut shortcut `Shift + Right-clic`)

- Follow cursor toggle : When activated the cursor follow the active the active object

- [breakdowner operator for object mode](https://blenderartists.org/t/pose-mode-animation-tools-for-object-mode/1221322), auto-keymap on : Shift + E 

- Line extender help closing gaps between lines with control over layer target (-> need also control over frame targets)

- GP copy paste : world space cut-copy-paste (bake strokes). `Ctrl + Shift + X/C/V`
Store strokes in os'clipboard (easier cross blend copy)
cutting is use a more user friendly  (leave boundary points of left strokes untouched).  
Also Possible to copy whole selected layers.

- Auto update : you have an updater in the addon preference tabs (use the [CGcookie addon updater](https://github.com/CGCookie/blender-addon-updater))

### Where ?

Panel in sidebar : 3D view > sidebar 'N' > Gpencil


## Todo:

- Allow to render resolution from cam name

- Update multi output system:
    - use render layers + file outputs instead of batch by tweaking visibility

- BG Playblast enhancement:
    - Add a prefs to fallback to "simple" render.

- Settings-io for projects : Rsolution du film, palette folder, render settings...

- expose "tool setting" of canvas handling in sidebar (visible only in draw mode)

- Move automatically view to match GP Front (depending on Gpencil view settings)

- move GP keyframes selection and Object keyframe selection simultaneouly (Already Done by Tom Viguier at [Andarta](https://gitlab.com/andarta-pictures) 


---

## Changelog:

1.0.0:

- Compatible with official grease pencil tools
  - removed box deform and rotate canvas that existed in other

0.9.3:

- feat: keyframe jump keys are now auto-binded
- UI: added keyframe jump customisation in addon pref
- code: split keyframe jump in a separate file with his new key updater

0.9.2:

- doc: Correct download link (important, bugged the addon install) + update
- code: added tracker url
- updater: remove updater temp file, reset minimum version, turn off verbose mode

0.9.1:

- Public release
- prefs: added fps as part of project settings
  - check file use pref fps value (previously used harcoded 24fps value)
- cleanup: Remove wip GMIC-bridge tools that need to be done separately (if needed)
- update: apply changes in integrated copy-paste from the last version of standalone addon
- doc: Added fully-detailed french readme


0.8.0:

- feat: Added background_rendering playblast, derivating from Tonton's playblaster
  - stripped associated properties from properties.py and passed as wm props.

0.7.2:

- fix: Palette importer bug

0.7.0:

- feat: auto create empty frame on color layer

0.6.3:

- shortcut: added 1,2,3 to change sculpt mask mode (like native edit mode shortcut)

0.6.2:

- feat: colorisation, Option to change stop lines length
- Change behavior of `cursor_snap` ops when a non-GP object is selected to mode: `surface project`
- Minor refactor for submodule register

0.6.1:

- feat: render objects grouped, one anim render with all ticked object using manual output name 

0.6.0:

- feat: Include GP clipoard's "In place" custom cut/copy/paste using OS clipboard

0.5.9:

- feat: render exporter
  - Render a selection of GP object isolated from the rest
  - added exclusions names for GP object listing
  - setup settings and output according to a name
  - open render folder
- check file: set onion skin keyframe filter to 'All_type' on all GP datablock
- check file: set scene resolution to settings in prefs (default 2048x1080)

0.5.8:

- feat: GP material append on active object from single blend file

0.5.7:

- Added warning message for cursor snapping

0.5.5 - 0.5.6:

- check file: added check for placement an projection mode for Gpencil.
- add a slider to change edit_lines_opacity globally for all GP data at once
- check file: auto-check additive drawing (to avoid empty frame with "only selected channel" in Dopesheet)

0.5.4:

- feat: anim manager in his own GP_toolbox submenu:
  - button to list disabled anim (allow to quickly check state of the scene)
  - disable/enable all fcurve in for GP object or other object separately to paint
  - shift clic to target selection only
- check file: added disabled fcurved counter alert with detail in console

0.5.3:

- fix: broken obj cam (add custom prop on objcam to track wich was main cam)
- check file option: change select active tool (choice added in addon preferences)

0.5.2:

- Revert back obj_cam operator for following object (native lock view follow only translation)
- Changed method for canvas rotation to more robust rotate axis.
- Add operators on link checker to open containing folder/file of link
- Refactor: file checkers in their own file

0.5.1:

- fix: error when empty material slot on GP object.
- fix: cursor snap on GP canvas when GP is parented
- change: Deleted obj cam (and related set view) operator
- change: blacker note background for playblast (stamp_background)
- feat: Always playblast from main camera (if in draw_cam)
- feat: Handler added to Remap relative on save (pre)
- ops: Check for broken links with porposition to find missing files
- ops: Added basic hardcoded file checker
  - Lock main cam
  - set scene percentage at 100
  - set show slider and sync range
  - set fps to 24

0.4.6:

- feat: basic Palette manager with base material check and warning

0.4.5:

- open blender config folder from addon preference
- fix: obj cam parent on selected object
- added wip rotate canvas axis file. still not ready to replace current canvas rotate:
  - freeview : bug when rotating free viewfrom cardianl views
  - camview: potential bug when cam is parented with some specific angle (could not reproduce)


0.4.4:

- feat: added cursor follow handlers and UI toggle

0.4.3:

- change playblast out to 'images' and add playblast as name prefix

0.4.2:

- feat: GP canvas cursor snap wiht new `view3d.cusor_snap` operator
- fix: canvas rotate works with parented camera !
- wip: added an attmpt to replicate camera rotate modal with view matrix but no luck.

0.4.1:

- feat: Alternative cameras: parent to main cam (roll without affecting main cam), parent to active object at current view (follow current Grease pencil object)

0.4.0:

- Added a standalone working version of box_deform (stripped preferences keeping only best configuration with autoswap)

0.3.8:

- UI: expose onion skin in interface
- UI: expose autolock in interface
- UI : putted tint layers in a submenu
- code: refactor, pushed most of class register in their owner file
- tool: tool to rename current or all grease pencil datablock with different name than container object

0.3.7:

- UI: new interface with tabs for addon preferences
- UI: possible to disable color panel from preference (might be deleted if unusable)
- docs: change readme changelog format and correct doc

0.3.6:

- UI: Stoplines : add a button for quickly set stoplines visibility.

0.3.5:

- Fix : No more camera rotation undo when ctrl+Z on next stroke (canvas rotate push and undo)
- Fix: Enter key added to valid object-breakdown modal.

0.3.3:

- version 1 beta (stable) of line gap closing tools for better bucket fill tool performance with UI

0.3.3:

- version 1 beta of gmic colorize
- variant of `screen.gp_keyframe_jump` through keymap seetings

0.3.0:

- new homemade [breakdowner operator for object](https://blenderartists.org/t/pose-mode-animation-tools-for-object-mode/1221322) mode with auto keymap : Shift + E
- GP cutter shortcut ops to map with `wm.temp_cutter` (with "Any" as press mode) or `wm.sticky_cutter` (Modal sticky-key version)

0.2.3:

- add operator to `screen.gp_keyframe_jump`
- add shortcut to rotate canvas
- fix duplicate class

0.2.2:

- separated props resolution_percentage parameter
- playblast options for launching folder and opening folder

0.2.1:

- playblast feature
- Button to go zoom 100% or fit screen
- display scene resolution with res indicator
- Fix reference panel : works with video and display in a box layout.
- close pseudo-color panel by default (plan to move it to Gpencil tab)

0.2.0:

- UI: Toggle camera background images from Toolbox panel
- UI: quick access to passepartout
- Feature: option to use namespace for pseudo color

0.1.5:

- added CGC-auto-updater

0.1.3:

- flip cam x
- inital stage of overlay toggle (need pref/multiple pref)

0.1.2:

- subpanel of GP data (instead of direct append)
- initial commit with GP pseudo color